function love.load()
	love.physics.setMeter(32) 
	
	world = love.physics.newWorld(0, 0, true) 
		world:setCallbacks(beginContact, endContact, preSolve, postSolve)
		
	logmessage = "" 
	logmessage2 = "" 
	
	persisting = 0    -- we'll use this to store the state of repeated callback calls

	--mouse pointer variables
	love.mouse.setVisible(false)
	
	cursor_visible = true
	mouse_down = false
	
	--spells
	selected_spell = 1

	--collision
	
	enemyhit = false
	fireballhit = false
	icenovahit = false
	fireballexphit = false
	playerhit = false
	
	--fire spell
	fireball_casted = false
	fireball_casting = false
	fireball_charged = false
	fireball_cast_timer = 0
	fireball_damage = 0
	
	fire_delay = false
	fire_delay_timer = 0
	fireball_x_ratio = 0 
    fireball_y_ratio = 0
	
	--ice spell
	ice_spell_casting = false
	ice_spell_casted = false

	ice_explode_time = 0.1
	ice_explosion_scale = 0

	ice_fade = false
	ice_fade_scale = 0
	ice_fade_alpha = 1
	ice_fade_time = 5

	ice_target_scale = 0
	ice_target_scale_time = 1

	ice_delay = false
	ice_delay_timer = 0
	ice_delay_time_max = 5
	
	icenova_mouse_x = 0
	icenova_mouse_y = 0
	
	--initial graphics setup
	love.graphics.setMode(650, 650, false, true, 0) --set the window dimensions to 650 by 650

	generate_world()
end

function generate_world()

	--physics objects
	objects = {} -- table to hold all our physical objects
	
	--tiles
	tile = {}
	for i=0,6 do -- change 3 to the number of tile images minus 1.
		tile[i] = love.graphics.newImage( "tile"..i..".png" )
	end
	
	-- map variables
	map_w = 20
	map_h = 20
	map_x = 0
	map_y = 0
	map_offset_x = 30
	map_offset_y = 30
	map_display_w = 20
	map_display_h = 20
	tile_w = 64
	tile_h = 64 
	
	--generate map
	map = {}
	map={
	{ 4, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 5}, 
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
	{ 3, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 6},
    }
	
	--let's create the ground
	objects.ground = {}
	objects.ground.body = love.physics.newBody(world, 650/2, 650-50/2) --remember, the shape (the rectangle we create next) anchors to the body from its center, so we have to move it to (650/2, 650-50/2)
	objects.ground.shape = love.physics.newRectangleShape(650, 50) --make a rectangle with a width of 650 and a height of 50
	objects.ground.fixture = love.physics.newFixture(objects.ground.body, objects.ground.shape); --attach shape to body
	objects.ground.fixture:setUserData("ground")  
	
	--let's create the ceiling
	objects.ceiling = {}
	objects.ceiling.body = love.physics.newBody(world, 650/2, 150-250/2) --remember, the shape (the rectangle we create next) anchors to the body from its center, so we have to move it to (650/2, 650-50/2)
	objects.ceiling.shape = love.physics.newRectangleShape(650, 50) --make a rectangle with a width of 650 and a height of 50
	objects.ceiling.fixture = love.physics.newFixture(objects.ceiling.body, objects.ceiling.shape); --attach shape to body
	objects.ceiling.fixture:setUserData("ceiling")  
	
	--let's create wall1
	objects.wall1 = {}
	objects.wall1.body = love.physics.newBody(world, 50/2, 450-250/2) --remember, the shape (the rectangle we create next) anchors to the body from its center, so we have to move it to (650/2, 650-50/2)
	objects.wall1.shape = love.physics.newRectangleShape(50, 550) --make a rectangle with a width of 650 and a height of 50
	objects.wall1.fixture = love.physics.newFixture(objects.wall1.body, objects.wall1.shape); --attach shape to body
	objects.wall1.fixture:setUserData("wall1")  
	
	--let's create wall2
	objects.wall2 = {}
	objects.wall2.body = love.physics.newBody(world, 600+50/2, 450-250/2) --remember, the shape (the rectangle we create next) anchors to the body from its center, so we have to move it to (650/2, 650-50/2)
	objects.wall2.shape = love.physics.newRectangleShape(50, 550) --make a rectangle with a width of 650 and a height of 50
	objects.wall2.fixture = love.physics.newFixture(objects.wall2.body, objects.wall2.shape); --attach shape to body
	objects.wall2.fixture:setUserData("wall2") 

	--let's create a player
	objects.player = {}
	objects.player.body = love.physics.newBody(world, 650/2, 650/2, "dynamic") --place the body in the center of the world and make it dynamic, so it can move around
	objects.player.body:setLinearDamping(2)
	objects.player.body:setMass(1)
	objects.player.image = love.graphics.newImage("player.png")
	objects.player.shape = love.physics.newCircleShape(objects.player.image:getWidth()/2)
	objects.player.fixture = love.physics.newFixture(objects.player.body, objects.player.shape, 1) -- Attach fixture to body and give it a density of 1.
	objects.player.fixture:setUserData("player")  

	objects.graphics = {}
	
	--enemies
	objects.enemies = {}
	objects.graphics.testenemy = love.graphics.newImage("enemy.png")
	objects.graphics.testenemyfrozen = love.graphics.newImage("enemyfrozen.png")
	objects.graphics.testenemybig = love.graphics.newImage("enemybig.png")
	objects.graphics.testenemybigfrozen = love.graphics.newImage("enemybigfrozen.png")
	
	--fireball
	objects.fireball = {}
	objects.graphics.fireball = love.graphics.newImage("fire_cursor.png")
	
	objects.fireballexposion = {}
	
	--ice nova
	objects.icenova = {}
	objects.graphics.icenova_circle_image = love.graphics.newImage("ice_circle.png")
	objects.graphics.icenova_innercircle_image = love.graphics.newImage("ice_circle_inside.png")
	objects.graphics.icenova_splash_image = love.graphics.newImage("ice_circle_splash.png")
	
	--enemy_spawn(100, 100, "testenemy")
	--enemy_spawn(200, 100, "testenemybig")
	--enemy_spawn(300, 100, "testenemy")
	--enemy_spawn(400, 100, "testenemybig")
	--enemy_spawn(500, 100, "testenemy")
end

function character_controls()
	--movement variables
	
	local center_screen_x = 650/2
	local center_screen_y = 650/2
	local move_force = 1000
	local move_diag_force = 600

	objects.player.x, objects.player.y = objects.player.body:getPosition()
	objects.player.body:setAngle(math.getAngle(objects.player.x, objects.player.y, love.mouse.getX(), love.mouse.getY()) + math.pi * 0.5)

	if love.keyboard.isDown("1") then
		selected_spell = 1
	elseif love.keyboard.isDown("2") then
		selected_spell = 2
	end
	
	if mouse_down == false then
		objects.player.body:setLinearDamping(2)
		
		if love.keyboard.isDown("w") then 											--if up
		
			if love.keyboard.isDown("a") then 										--and left
				objects.player.body:applyForce(-move_diag_force, -move_diag_force) 	--up left
			elseif love.keyboard.isDown("d") then 									--and right
				objects.player.body:applyForce(move_diag_force, -move_diag_force)  	--up right	
			elseif love.keyboard.isDown("s") then									--and down
			else
				objects.player.body:applyForce(0, -move_force)						--just up
			end
			
		elseif love.keyboard.isDown("s") then 										--if down
			if love.keyboard.isDown("a") then 										--and left
				objects.player.body:applyForce(-move_diag_force, move_diag_force)		--down left
			elseif love.keyboard.isDown("d") then 									--and right
				objects.player.body:applyForce(move_diag_force, move_diag_force)		--down right
			else
				objects.player.body:applyForce(0, move_force)							--just down
			end
		
		elseif love.keyboard.isDown("a") then 										--if left
			if love.keyboard.isDown("d") then 										--and right
			else
				objects.player.body:applyForce(-move_force, 0)						--just left
			end
			
		elseif love.keyboard.isDown("d") then 										--if right
				objects.player.body:applyForce(move_force, 0)
		end
	else
		objects.player.body:setLinearDamping(5)
	end
	
	
end

function fire_spell_caster(dt)
	
	local fireball_force = 50000
	local difference_x = 0
	local difference_y = 0
	local fire_delay_timer_max = 1
	local fireball_cast_time_max = 1
	local fireball_dam_min = 10
	local fireball_dam_add = 100
	local fireball_explode = 0
	
	if fire_delay == true then --if we've just fired and cant fire again yet
		fire_delay_timer = fire_delay_timer + (dt / fire_delay_timer_max)
		if fire_delay_timer > 1 then 
			fire_delay = false
			fire_delay_timer = 0
		end 
	else
		if love.mouse.isDown ("l") then --if the mouse is pressed
			
			if mouse_down == false then 
				mouse_down = true
			end
			
			fire_spell_casting = true
			
			fireball_cast_timer = fireball_cast_timer + (dt / fireball_cast_time_max)
			fireball_damage = fireball_dam_min + (fireball_dam_add*fireball_cast_timer)
			
			if fireball_damage > (fireball_dam_min + fireball_dam_add) then
				fireball_damage = fireball_dam_min + fireball_dam_add
			end
			
			if fireball_cast_timer > 0.5 then
				fireball_explode = 1	--fireball will explode on hit
			end
			
			if fireball_cast_timer > 1 then
				fireball_cast_timer = 1
				fireball_charged = true --fireball at maximum charge
			end
			
		else
			if fire_spell_casting == true then
			
				fire_spell_casting = false
				fire_spell_release = true
				
				fireball_cast_timer = 0
				
				mouse_down = false
				
				objects.player.x, objects.player.y = objects.player.body:getPosition()
				
				difference_x = love.mouse.getX() - objects.player.x
				difference_y = love.mouse.getY() - objects.player.y

				if difference_x >= 0 then --calculate initial initial force to the fireballds
					if difference_y >= 0 then 
						fireball_x_ratio =  difference_x / (difference_x + difference_y)
						fireball_y_ratio =  difference_y / (difference_x + difference_y)
					elseif difference_y < 0 then
						fireball_x_ratio =  difference_x / (difference_x + (-difference_y))
						fireball_y_ratio =  -1*((-difference_y) / (difference_x + (-difference_y)))
					end
					
				elseif difference_x < 0 then
					if difference_y >= 0 then
						fireball_x_ratio =  -1*((-difference_x) / ((-difference_x) + difference_y))
						fireball_y_ratio =  difference_y / ((-difference_x) + difference_y)
					elseif difference_y < 0 then
						fireball_x_ratio =  -1*((-difference_x) / ((-difference_x) + (-difference_y)))
						fireball_y_ratio =  -1*((-difference_y) / ((-difference_x) + (-difference_y)))
					end
				end
				
				local new_table = {}
				new_table.body = love.physics.newBody(world, objects.player.x, objects.player.y, "dynamic")
				new_table.body:setMass(1)
				new_table.image = objects.graphics.fireball
				new_table.shape = love.physics.newCircleShape(new_table.image:getWidth()/2)
				new_table.fixture = love.physics.newFixture(new_table.body, new_table.shape, 1)
				new_table.fixture:setUserData("fireball"..#objects.fireball)
				new_table.fixture:setSensor(true)
				new_table.colliding = 0
				new_table.explode = 1				--fireball_explode
				new_table.damage = fireball_damage
				table.insert(objects.fireball,new_table)
				
				objects.fireball[#objects.fireball].body:applyForce(	fireball_x_ratio * fireball_force, 
																		fireball_y_ratio * fireball_force)
				
				--[[logmessage2 = (	"forcex = "..fireball_x_ratio * fireball_force..
								" forcey = "..fireball_y_ratio * fireball_force..
								"\nxratio "..fireball_x_ratio.." yratio "..fireball_y_ratio..
								"\ndifference_x "..difference_x.." difference_y "..difference_y )]]
																	
			end		
		end
	end
	
	--for i,v in pairs(objects.fireball) do
		--ice_delay_timer = ice_delay_timer + (dt / ice_delay_time_max)
	--end
end

function ice_spell_caster(dt)
	
	if ice_delay == true then 														--start the timer on the delay
		ice_delay_timer = ice_delay_timer + (dt / ice_delay_time_max)
		if ice_delay_timer > 1 then 
			ice_delay = false
			ice_delay_timer = 0
		end 
	else
		if love.mouse.isDown ("l") then  --if the mouse is down, create the ice nova

			ice_target_scale = ice_target_scale + (dt / ice_target_scale_time)
			if ice_target_scale > 1 then 
				ice_target_scale = 1
			end		
			
			if mouse_down == false then 
				icenova_mouse_x = love.mouse.getX()
				icenova_mouse_y = love.mouse.getY()
				mouse_down = true
				cursor_visible = false
			end
			
			ice_spell_casting = true													--ice spell is being cast
		else
			if ice_spell_casting == true then
				ice_spell_casting = false
				ice_spell_explode = true
			end
			
			mouse_down = false
			cursor_visible = true
		end
	end
	
	if ice_spell_explode == true then
		
		if ice_delay == false then														--if the ice spell has been cast, start the delay between casts
			ice_delay = true
		end
		
		if ice_explosion_scale < ice_target_scale then
			ice_explosion_scale = ice_explosion_scale + (dt / ice_explode_time)
		else
		
			local new_table = {}
			--new_table.x = icenova_mouse_x
			--new_table.y = icenova_mouse_y
			new_table.body = love.physics.newBody(world, icenova_mouse_x, icenova_mouse_y, "static")
			new_table.shape = love.physics.newCircleShape((objects.graphics.icenova_splash_image:getWidth()/2)*ice_explosion_scale)
			new_table.fixture = love.physics.newFixture(new_table.body, new_table.shape, 1)
			new_table.fixture:setUserData("icenova"..#objects.icenova)
			new_table.fixture:setSensor(true)
			new_table.colliding = 0
			
			table.insert(objects.icenova, new_table )
			
			ice_fade = true
			ice_fade_scale = ice_explosion_scale
			ice_spell_explode = false
			ice_target_scale = 0
			ice_explosion_scale = 0
			
		end
	end
end		

function spell_update(dt)
--[[
	if selected_spell == 1 then
		fire_spell_caster(dt)
	elseif selected_spell == 2 then
		ice_spell_caster(dt)
	end
	
	--ice spell fade	
	if ice_fade == true then
		ice_fade_alpha = ice_fade_alpha - (dt / ice_fade_time)
		if ice_fade_alpha < 0 then
			ice_fade_scale = 0
			ice_fade_alpha = 1
			ice_fade = false
		end
	end
	
	if string.find(objects_hit_1, "fireball") and string.find(objects_hit_2, "fireball") then
		logmessage2 = "firefire"
	elseif string.find(objects_hit_1, "fireball") and string.find(objects_hit_2, "player") then
		logmessage2 = "fireplayer"
	elseif string.find(objects_hit_1, "player") and string.find(objects_hit_2, "fireball") then
		logmessage2 = "playerfire"
	end
	
	local fireball_x = 0
	local fireball_y = 0
	
	--fireball collision
	if fireballhit == true and playerhit == false then
	
		for i,v in pairs(objects.fireball) do 
			if objects.fireball[i].colliding == 1 then
				objects.fireball[i].colliding = 0
				
				if objects.fireball[i].explode == 1 then
					fireball_x, fireball_y = objects.fireball[i].body:getPosition()
					
					local new_table = {}
					new_table.body = love.physics.newBody(world, fireball_x, fireball_y, "dynamic")
					new_table.body:setMass(1)
					new_table.image = objects.graphics.icenova_splash_image
					new_table.shape = love.physics.newCircleShape(new_table.image:getWidth()/2)
					new_table.fixture = love.physics.newFixture(new_table.body, new_table.shape, 1)
					new_table.fixture:setUserData("fireballexp"..#objects.fireballexposion)
					new_table.fixture:setSensor(true)
					new_table.colliding = 0
					new_table.damage = objects.fireball[i].damage/4
					table.insert(objects.fireballexposion, new_table)
				end
				
				objects.fireball[i].body:destroy()
				objects.fireball[i] = nil
			end
		end
	end
	
	if icenovahit == true then
	
		for i,v in pairs(objects.icenova) do
			if objects.icenova[i].colliding == 1 then
				objects.icenova[i].colliding = 0
				objects.icenova[i].body:destroy()
				objects.icenova[i] = nil
			end
		end
	end
]]
end

function enemy_update(dt)

	--------------------------------------------------------------
	--check collisions
	--------------------------------------------------------------

	if enemyhit == true then
		for i,v in pairs(objects.enemies) do
			if objects.enemies[i].colliding == 1 then
				objects.enemies[i].colliding = 0
				--fireball hit
				if fireballhit == true then
					for j,w in pairs(objects.fireball) do
						if objects.fireball[j].getUserData == objects_hit_1 or objects_hit_2 then
							--logmessage2 = objects.fireball[j].damage
							objects.enemies[i].health = objects.enemies[i].health - objects.fireball[j].damage
						end
					end
					fireballhit = false
				end
				--explosion hit
				if fireballexphit == true then
					logmessage2 = logmessage2.."FIREBALLEXPCHECK"
					for j,w in pairs(objects.fireballexposion) do
						if objects.fireballexposion[j].getUserData == objects_hit_1 or objects_hit_2 then
							logmessage2 = logmessage2.." expdam "..objects.fireballexposion[j].damage
							objects.enemies[i].health = objects.enemies[i].health - objects.fireballexposion[j].damage
						end
					end
					fireballexphit = false
				end
				
				--icenova hit
				if icenovahit == true then
					objects.enemies[i].frozen = 1
					if objects.enemies[i].enemytype == "testenemy" then
						objects.enemies[i].image = objects.graphics.testenemyfrozen
					elseif objects.enemies[i].enemytype == "testenemybig" then
						objects.enemies[i].image = objects.graphics.testenemybigfrozen
					end
					icenovahit = false
				end
			end
		end		
	end
	
	--------------------------------------------------------------
	--enemy dead?
	--------------------------------------------------------------
	for i,v in pairs(objects.enemies) do
		if objects.enemies[i].health <= 0 then
			--logmessage2 = logmessage2 .. "\n" ..objects.enemies[i].health
			objects.enemies[i].body:destroy()
			objects.enemies[i] = nil
		end
	end
	
	--------------------------------------------------------------
	-- enemy still frozen?
	--------------------------------------------------------------
	for i,v in pairs(objects.enemies) do
		if objects.enemies[i].frozen == 1 then
			local freezetimer = objects.enemies[i].enemy_frozen_timer
			local freezetimermax = objects.enemies[i].enemy_frozen_time_max
			freezetimer = freezetimer + (dt / freezetimermax)
			
			if freezetimer > 1 then
				objects.enemies[i].frozen = 0
				freezetimer = 0
				if objects.enemies[i].enemytype == "testenemy" then
					objects.enemies[i].image = objects.graphics.testenemy
					--logmessage2 = freezetimermax
				elseif objects.enemies[i].enemytype == "testenemybig" then
					objects.enemies[i].image = objects.graphics.testenemybig
				end					
			end
			
			objects.enemies[i].enemy_frozen_timer = freezetimer
			
		end
	end
	
	--------------------------------------------------------------
	-- enemy movement
	--------------------------------------------------------------
	enemy_movement = false
	if enemy_movement == true then 
	for i,v in pairs(objects.enemies) do
		local move_force = 500
		local enemy_x = 0 
		local enemy_y = 0
		local difference_x = 0
		local difference_y = 0
		local enemy_ratio_x = 0
		local enemy_ratio_y = 0
		
		if objects.enemies[i].frozen == 0 then
			objects.enemies[i].body:setLinearDamping(2)
			enemy_x, enemy_y = objects.enemies[i].body:getPosition()
			
			difference_x = objects.player.x - enemy_x
			difference_y = objects.player.y - enemy_y

			if difference_x > 0 then --calculate initial initial force to the enemy
				if difference_y > 0 then 
					enemy_ratio_x =  difference_x / (difference_x + difference_y)
					enemy_ratio_y =  difference_y / (difference_x + difference_y)
				elseif difference_y < 0 then
					enemy_ratio_x =  difference_x / (difference_x + (-difference_y))
					enemy_ratio_y =  -1*((-difference_y) / (difference_x + (-difference_y)))
				end
				
			elseif difference_x < 0 then
				if difference_y > 0 then
					enemy_ratio_x =  -1*((-difference_x) / ((-difference_x) + difference_y))
					fireball_y_ratio =  difference_y / ((-difference_x) + difference_y)
				elseif difference_y < 0 then
					enemy_ratio_x =  -1*((-difference_x) / ((-difference_x) + (-difference_y)))
					enemy_ratio_y =  -1*((-difference_y) / ((-difference_x) + (-difference_y)))
				end
			end			
			
			objects.enemies[i].body:applyForce(	enemy_ratio_x * move_force, 
												enemy_ratio_y * move_force)
		elseif objects.enemies[i].frozen == 1 then
			objects.enemies[i].body:setLinearDamping(2000)
		end
	end
	end
end

function enemy_spawn(x, y, enemytype)
	local new_table = {}
	
	if enemytype == "testenemy" then
		new_table.image = objects.graphics.testenemy
		new_table.shape = love.physics.newCircleShape(new_table.image:getWidth()/2)
		new_table.body = love.physics.newBody(world, x, y, "dynamic")
		new_table.body:setMass(1)
		new_table.body:setLinearDamping(2)
		new_table.fixture = love.physics.newFixture(new_table.body, new_table.shape, 1)
		new_table.fixture:setUserData("enemy"..#objects.enemies)
		new_table.enemytype = enemytype
		new_table.frozen = 0
		new_table.health = 100
		new_table.enemy_frozen_timer = 0
		new_table.enemy_frozen_time_max = 1
	
	elseif enemytype == "testenemybig" then
		new_table.image = objects.graphics.testenemybig
		new_table.shape = love.physics.newCircleShape(new_table.image:getWidth()/2)
		new_table.body = love.physics.newBody(world, x, y, "dynamic")
		new_table.body:setMass(1)
		new_table.body:setLinearDamping(2)
		new_table.fixture = love.physics.newFixture(new_table.body, new_table.shape, 1)
		new_table.fixture:setUserData("enemy"..#objects.enemies)
		new_table.enemytype = enemytype
		new_table.frozen = 0
		new_table.health = 300
		new_table.enemy_frozen_timer = 0
		new_table.enemy_frozen_time_max = 5
	end	
	
	table.insert(objects.enemies,new_table)
	
end



function love.update(dt)
	world:update(dt)
	character_controls()
	enemy_update(dt)
	spell_update(dt)
	
end

---------------------------------------------------
--   Drawing
---------------------------------------------------

function draw_cursor()
	if cursor_visible == true then 
		if selected_spell == 1 then
			cursor_image = love.graphics.newImage("fire_cursor.png")
		elseif selected_spell == 2 then
			cursor_image = love.graphics.newImage("ice_cursor.png")
		end
		
		love.graphics.draw(cursor_image, love.mouse.getX()-12, love.mouse.getY()-12)
	end
end

function draw_ice_spell()
	if selected_spell == 2 then
		cursor_image = love.graphics.newImage("fire_cursor.png")
	
		ice_circle_offset_x = (objects.graphics.icenova_circle_image:getWidth()/2)
		ice_circle_offset_y = (objects.graphics.icenova_circle_image:getHeight()/2)
		
		ice_circle_inside_offset_x = (objects.graphics.icenova_innercircle_image:getWidth()/2)
		ice_circle_inside_offset_y = (objects.graphics.icenova_innercircle_image:getHeight()/2)
		
		ice_nova_splash_image_offset_x = (objects.graphics.icenova_splash_image:getWidth()/2)
		ice_nova_splash_image_offset_y = (objects.graphics.icenova_splash_image:getHeight()/2)
		
		
		if mouse_down == true then
			
			love.graphics.draw(	objects.graphics.icenova_circle_image, 
								icenova_mouse_x - ice_circle_offset_x, 
								icenova_mouse_y - ice_circle_offset_y) --draw the outer circle
		
			love.graphics.draw(	objects.graphics.icenova_innercircle_image, 
								icenova_mouse_x, icenova_mouse_y, 
								0, ice_target_scale, ice_target_scale, 
								ice_circle_inside_offset_x, 
								ice_circle_inside_offset_y) --draw the inner circle
		end
		
		if ice_spell_explode == true then
		
			love.graphics.draw(	objects.graphics.icenova_splash_image, 
								icenova_mouse_x, icenova_mouse_y,  
								0, ice_explosion_scale, ice_explosion_scale, 
								ice_nova_splash_image_offset_x, 
								ice_nova_splash_image_offset_y)
								
		end
	
	end	

	if ice_fade == true then
		love.graphics.setColor( 255, 255, 255, (ice_fade_alpha*255))
		
		
		love.graphics.draw(	objects.graphics.icenova_splash_image, 
							icenova_mouse_x, icenova_mouse_y,  
							0, ice_fade_scale, ice_fade_scale, 
							ice_nova_splash_image_offset_x, 
							ice_nova_splash_image_offset_y)
		
		love.graphics.setColor( 255, 255, 255, 255)
	end
	
end

function draw_stuff(t)
	for i,v in pairs(t) do
		
		love.graphics.draw(	v.image, 
						v.body:getX(), v.body:getY(), 
						v.body:getAngle(),  
						1, 1, 
						v.image:getWidth()/2, 
						v.image:getHeight()/2)
	end
end

function draw_collision(t)
	love.graphics.setColor(50, 50, 50)
	for i,v in pairs(t) do
		love.graphics.circle("fill", v.body:getX(),v.body:getY(), v.shape:getRadius())
	end
	love.graphics.setColor(255, 255, 255)
end

function draw_player()

	love.graphics.draw(	objects.player.image, 
						objects.player.body:getX(), objects.player.body:getY(), 
						objects.player.body:getAngle(), 
						1, 1, 
						objects.player.image:getWidth()/2, 
						objects.player.image:getHeight()/2)
end

function draw_world()
	love.graphics.setColor(35, 80, 135) -- set the drawing color to green for the ground
	love.graphics.polygon("fill", objects.ground.body:getWorldPoints(objects.ground.shape:getPoints())) 	-- draw a "filled in" polygon using the ground's coordinates
	love.graphics.polygon("fill", objects.ceiling.body:getWorldPoints(objects.ceiling.shape:getPoints())) 	-- draw a "filled in" polygon using the ceiling's coordinates
	love.graphics.polygon("fill", objects.wall1.body:getWorldPoints(objects.wall1.shape:getPoints())) 		-- draw a "filled in" polygon using the wall1's coordinates 
	love.graphics.polygon("fill", objects.wall2.body:getWorldPoints(objects.wall2.shape:getPoints())) 		-- draw a "filled in" polygon using the wall2's coordinates 
	love.graphics.setColor( 255, 255, 255, 255)
end

function draw_gui()
	gui_fire 		= love.graphics.newImage("gui_fire.png")
	gui_ice 		= love.graphics.newImage("gui_ice.png")
	gui_selection 	= love.graphics.newImage("gui_selection.png")
	
	gui_offset_X    = 0
	gui_offset_Y	= 550
	
	love.graphics.draw(gui_fire, gui_offset_X, gui_offset_Y)
	love.graphics.draw(gui_ice, gui_offset_X+100, gui_offset_Y)
	love.graphics.draw(gui_selection, gui_offset_X + (selected_spell*100) - 100, gui_offset_Y+0)
end

function draw_fireball()
	draw_stuff(objects.fireballexposion)
	draw_stuff(objects.fireball)
	local charge_radius = 0
	local overcharge = 0
	if fireball_cast_timer <= 0.5 then
		charge_radius =	objects.player.image:getWidth()/2 + 
						((objects.player.image:getWidth()/2)*(fireball_cast_timer*2))
	elseif fireball_cast_timer > 0.5 then
		charge_radius =	objects.player.image:getWidth()
		overcharge = (fireball_cast_timer - 0.5)*2 
		
		love.graphics.setColor(255, overcharge*255, overcharge*255)
		love.graphics.circle(	"fill", objects.player.body:getX(),objects.player.body:getY(), 
								objects.player.image:getWidth()*1.05)
		--logmessage2 = "overcharge"
	end
	
	love.graphics.setColor(255, 0, 0)
	love.graphics.circle(	"fill", objects.player.body:getX(),objects.player.body:getY(), charge_radius)
	love.graphics.setColor(255, 255, 255)					
end

function draw_map()

	--objects.player.body:getX()
	--objects.player.body:getY()
	--x_offset 
	--y_offset 
	for y=1, map_display_h do --draw map_display_h tiles in y
		for x=1, map_display_w do --draw map_display_w tiles in w                                                     
        love.graphics.draw( 
            tile[map[y+map_y][x+map_x]], 
            (x*tile_w)+map_offset_x, 
            (y*tile_h)+map_offset_y )
		end
	end
end

function love.draw()
	
	--draw_fireball()
	--draw_ice_spell()
	--draw_world()
	draw_map()
	draw_player()
	--draw_collision(objects.enemies)
	--draw_stuff(objects.enemies) --draw enemies
	
	
	--draw_gui()
	draw_cursor()

	if string.len(logmessage) > 768 then    -- cleanup when 'text' gets too long
        logmessage = "" 
    end
	
	love.graphics.print(logmessage, 10, 10)	
	love.graphics.print(logmessage2, 10, 400)

end

function math.getAngle(x1,y1, x2,y2) return math.atan2(y2-y1, x2-x1) end

function beginContact(a, b, coll)
    x,y = coll:getNormal()
	
	logmessage = logmessage.."\n"..a:getUserData().." colliding with "..b:getUserData().." with a vector normal of: "..x..", "..y	
	
	test_object_hits(a, b, "fireball")
	test_object_hits(a, b, "fireballexp")
	test_object_hits(a, b, "icenova")
	test_object_hits(a, b, "enemy")
	
end

function endContact(a, b, coll)
    persisting = 0

	logmessage = logmessage.."\n"..a:getUserData().." uncolliding with "..b:getUserData()

end

function preSolve(a, b, coll)
    if persisting == 0 then    -- only say when they first start touching
        --logmessage = logmessage.."\n"..a:getUserData().." touching "..b:getUserData()
    elseif persisting < 20 then    -- then just start counting
        --logmessage = logmessage.." "..persisting
    end
    persisting = persisting + 1    -- keep track of how many updates they've been touching for
end

function postSolve(a, b, coll)
end

function test_object_hits(a, b, object_type)
	--test_object_hits, return important data
	if object_type == "fireball" then 
		object_table = objects.fireball
	elseif object_type == "fireballexp" then 
		object_table = objects.fireballexposion
	elseif object_type == "icenova" then
		object_table = objects.icenova
	elseif object_type == "enemy" then
		object_table = objects.enemies
	elseif object_type == "player" then
		object_table = objects.player
	end

	for i,v in pairs(object_table) do
		if string.find(a:getUserData(), object_type) then
			if a:getUserData() == object_table[i].fixture:getUserData() then
				object_table[i].colliding = b:getUserData()
				--logmessage2 = 	logmessage2 .."a ".. a:getUserData().. " " ..b:getUserData()..i
			end
		end
	end

	if object_type == "fireball" then 
		objects.fireball = object_table
	elseif object_type == "icenova" then
		objects.icenova = object_table
	elseif object_type == "enemy" then
		objects.enemies = object_table
	elseif object_type == "fireballexp" then 
		objects.fireballexposion = object_table
	elseif object_type == "player" then
		objects.player = object_table
	end
end

function process_collision()
	process_col_table(objects_hit_1)
	process_col_table(objects_hit_2)
end

function process_col_table(t)

	if not t == nil then
		for i, v in pairs(t) do
		
			if string.find(objects_hit_1[i], "enemy") or 
			string.find(objects_hit_2[i], "enemy") then
				enemyhit = true
			end
			
			if string.find(objects_hit_1[i], "fireball") or 
			string.find(objects_hit_2[i], "fireball") then
				fireballhit = true
			end
			
			if string.find(objects_hit_1[i], "icenova") or 
			string.find(objects_hit_2[i], "icenova") then
				icenovahit = true
			end
			
			if string.find(objects_hit_1[i], "fireballexp") or 
			string.find(objects_hit_2[i], "fireballexp") then
				fireballexphit = true
			end
			
			if string.find(objects_hit_1[i], "player") or 
			string.find(objects_hit_2[i], "player") then
				playerhit = true
			end
		end
	end
end

function reset_collision_check()
	objects_hit_1 = {}
	objects_hit_2 = {}
	enemyhit = false
	fireballhit = false
	icenovahit = false
	fireballexphit = false
	playerhit = false
end
